#include <algorithm>
#include <cstring>
#include <iostream>
#include <list>
#include <vector>

#include <boost/type_traits.hpp>

using namespace std;
using namespace boost;

namespace  details {

  template<class iterator>
  void fill_impl(iterator begin, iterator end, typename iterator_traits<iterator>::value_type val) {
    for (;begin!=end; ++begin)
      *begin=val;
  }
  
}

template<class iterator>
void my_fill(iterator begin, iterator end,  typename iterator_traits<iterator>::value_type value=typename iterator_traits<iterator>::value_type()) {
  details::fill_impl(begin, end, value);
}

template<class T>
void print_elmt(const T& t) {
  cout << t << endl;
}

int
main() {
//   int a[5];
//   for_each(&a[0], &a[5], print_elmt<int>);
//   my_fill(&a[0], &a[5],5);
//   for_each(&a[0], &a[5], print_elmt<int>);

//   char b[5];
//   for_each(&b[0], &b[5], print_elmt<char>);
//   my_fill(&b[0], &b[5], 'c');
//   for_each(&b[0], &b[5], print_elmt<char>);


//   std::list<int> li;
//   std::list<char> lc;
//   for (unsigned i=0; i < 5; ++i) {
//     li.push_back(5);
//     lc.push_back('c');
//   }
//   for_each(li.begin(), li.end(), print_elmt<int>);
//   for_each(lc.begin(), lc.end(), print_elmt<char>);  
//   my_fill(li.begin(), li.end(), 2);
//    my_fill(lc.begin(), lc.end(), 'd');
//   for_each(li.begin(), li.end(), print_elmt<int>);
//   for_each(lc.begin(), lc.end(), print_elmt<char>);  
  

  std::vector<int> vi;
  std::vector<char> vc;
  for (unsigned i=0; i < 5; ++i) {
    vi.push_back(5);
    vc.push_back('c');
  }
  for_each(vi.begin(), vi.end(), print_elmt<int>);
  for_each(vc.begin(), vc.end(), print_elmt<char>);  
  my_fill(vi.begin(), vi.end(), 2);
  my_fill(vc.begin(), vc.end(), 'd');
  for_each(vi.begin(), vi.end(), print_elmt<int>);
  for_each(vc.begin(), vc.end(), print_elmt<char>);  
  

  return 0;
}
