#include <iostream>
#include <vector>

#include <boost/array.hpp>
#include <boost/bind.hpp>
#include <boost/function.hpp>
#include <boost/unordered_map.hpp>

using namespace boost;
using namespace std;

class Sprite {
  static int ID;
  int x,y;
  int id;
public:
  Sprite(int _x=0, int _y=0): x(_x), y(_y), id(++ID) {}
  void up() {++x;}
  void down() {--x;}
  void left() {--y;}
  void right() {++y;}

  void render() { 
    cout << "ID: " << id << "\n>>X: " << x << ", Y: " << y << endl;
  }

  void move(int dir) {
    switch(dir) {
    case 0:
      up(); break;
    case 1:
      down(); break;
    case 2:
      left(); break;
    case 3:
      right(); break;
    default:
      break;
    }
  }
};

int Sprite::ID=0;

struct Action {
  typedef /* complete */  action;

  void register_action(char k, action a) { 
    // complete here
  }

  bool key(char k) {
    if (k=='\n') 
      return false;
    // complete here
    return true;
  }
  
  unordered_map<char, action > acts;
};

int bounded_random(int max) {
  double rnd= static_cast<double>(rand())/RAND_MAX;
  return static_cast<int>(rnd*max);
}


int
main() {
  
  // init part
  const unsigned max_sprite=4;
  array<Sprite,2> players;
  Action Aplayer1;
  Action Aplayer2;

  // Enregistrement interaction utilisateur
 
  // fin Enregistrement interaction utilisateur

  vector<Action*> actions;
  actions.push_back(&Aplayer1);
  actions.push_back(&Aplayer2);
  
  vector<Sprite> sprites;
  for (unsigned i=0; i < max_sprite; ++i) 
    sprites.push_back(Sprite(bounded_random(256), bounded_random(256)));
  
  
  
  // "motor part"
  while (1) {
    
    // get player position
    while (!Aplayer1.key(getchar()));
    while(!(Aplayer2.key(getchar())));

    // bind : one call for all the loop :(
      
  }
  
  return 0;
}

